"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const core_1 = require("@jimp/core");
const js_jpeg_1 = __importDefault(require("@jimp/js-jpeg"));
const js_png_1 = __importDefault(require("@jimp/js-png"));
const test_utils_1 = require("@jimp/test-utils");
const blit = __importStar(require("./index.js"));
const Jimp = (0, core_1.createJimp)({ formats: [js_jpeg_1.default, js_png_1.default], plugins: [blit.methods] });
(0, vitest_1.describe)("Blit over image", function () {
    const targetImg = Jimp.fromBitmap((0, test_utils_1.makeTestImage)("▴▴▴▴▸▸▸▸", "▴▴▴▴▸▸▸▸", "▴▴▴▴▸▸▸▸", "▴▴▴▴▸▸▸▸", "▾▾▾▾◆◆◆◆", "▾▾▾▾◆◆◆◆", "▾▾▾▾◆◆◆◆", "▾▾▾▾◆◆◆◆"));
    // stores the Jimp instances of the JGD images above.
    // prettier-ignore
    const srcImg = Jimp.fromBitmap((0, test_utils_1.makeTestImage)("□□□□□□", "□▥▥▥▥□", "□▥■■▥□", "□▥■■▥□", "□▥▥▥▥□", "□□□□□□"));
    (0, vitest_1.test)("blit on top, with no crop", () => {
        (0, vitest_1.expect)(targetImg.clone().blit(srcImg)).toMatchSnapshot();
    });
    (0, vitest_1.test)("blit on middle, with no crop", () => {
        (0, vitest_1.expect)(targetImg.clone().blit({ src: srcImg, x: 1, y: 1 })).toMatchSnapshot();
    });
    (0, vitest_1.test)("blit on middle, with x,y crop", () => {
        (0, vitest_1.expect)(targetImg
            .clone()
            .blit({ src: srcImg, x: 2, y: 2, srcX: 1, srcY: 1, srcW: 5, srcH: 5 })).toMatchSnapshot();
    });
    (0, vitest_1.test)("blit on middle, with x,y,w,h crop", () => {
        (0, vitest_1.expect)(targetImg
            .clone()
            .blit({ src: srcImg, x: 2, y: 2, srcX: 1, srcY: 1, srcW: 4, srcH: 4 })).toMatchSnapshot();
    });
    (0, vitest_1.test)("blit partially out, on top-left", () => {
        (0, vitest_1.expect)(targetImg.clone().blit({ src: srcImg, x: -1, y: -1 })).toMatchSnapshot();
    });
    (0, vitest_1.test)("blit partially out, on bottom-right", () => {
        (0, vitest_1.expect)(targetImg.clone().blit({ src: srcImg, x: 3, y: 3 })).toMatchSnapshot();
    });
});
//# sourceMappingURL=index.test.js.map